' Thanks goto sotoasty from codeguru.com for writing this class for me..
' I've made a few minour changes, and included a Event to alert the app 
' to any problems..

Imports Microsoft.Win32
Public Class UserInfo
    Enum Error_type
        Load_Err
        Save_Err
    End Enum

    Private rk As RegistryKey
    Private keyValue As String = "Software\IPChat"
    Private mvarIPAddress As String = "127.0.0.1"
    Private mvarSubNetMask As String = "255.255.255.0"
    Private mvarUserName As String = "Gremmy"
    Private mvarProgramPort As String = "1669"
    Public Event Int_Error(ByVal Err_val As Error_type)

    Friend Property IPAddress() As String
        Get
            Return mvarIPAddress
        End Get
        Set(ByVal value As String)
            mvarIPAddress = value
        End Set
    End Property

    Friend Property SubNetMask() As String
        Get
            Return mvarSubNetMask
        End Get
        Set(ByVal value As String)
            mvarSubNetMask = value
        End Set
    End Property

    Friend Property UserName() As String
        Get
            Return mvarUserName
        End Get
        Set(ByVal value As String)
            mvarUserName = value
        End Set
    End Property

    Friend Property DefaultPort() As String
        Get
            Return mvarProgramPort
        End Get
        Set(ByVal value As String)
            mvarProgramPort = value
        End Set
    End Property

    Public Sub Load()
        Try
            rk = Registry.CurrentUser.OpenSubKey(keyValue, False)
            mvarUserName = DirectCast(rk.GetValue("UserName", "NotSpecified"), String)
            rk.Close()
            rk = Registry.LocalMachine.OpenSubKey(keyValue, False)
            mvarProgramPort = DirectCast(rk.GetValue("ChatPort", "1669"), String)
            mvarIPAddress = DirectCast(rk.GetValue("LocalIPAddress", "127.0.0.1"), String)
            mvarSubNetMask = DirectCast(rk.GetValue("SubnetMask", "255.255.255.0"), String)
            rk.Close()
        Catch ex As Exception
            RaiseEvent Int_Error(Error_type.Load_Err)
        End Try
    End Sub

    Public Sub Save()
        Try
            rk = Registry.CurrentUser.CreateSubKey(keyValue)
        Catch ex As Exception
            RaiseEvent Int_Error(Error_type.Save_Err)
        Finally
            rk.SetValue("UserName", mvarUserName)
            rk.Close()
        End Try
        Try
            rk = Registry.LocalMachine.CreateSubKey(keyValue)
        Catch ex As Exception
            RaiseEvent Int_Error(Error_type.Save_Err)
        Finally
            rk.SetValue("ChatPort", mvarProgramPort.ToString)
            rk.SetValue("LocalIPAddress", mvarIPAddress)
            rk.SetValue("SubnetMask", mvarSubNetMask)
            rk.Close()
        End Try
    End Sub
End Class
